﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter.ExcelExporter;
using Infragistics.Documents.Excel;

namespace XamDataGridExcelExport
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<DataItem> data;

        public MainWindow()
        {
            InitializeComponent();

            data = DataItem.GetCollection();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            DataPresenterExcelExporter exporter = new DataPresenterExcelExporter();
            exporter.ExportStarted += new EventHandler<ExportStartedEventArgs>(exporter_ExportStarted);
            exporter.Export(this.xamDataGrid1, "xamDataPresenter1.xlsx", WorkbookFormat.Excel2007);
        }

        void exporter_ExportStarted(object sender, ExportStartedEventArgs e)
        {
            e.CurrentRowIndex = 1;
            e.CurrentWorksheet.Rows[0].Cells[0].Value = "Searched Criteria";
            e.CurrentWorksheet.Rows[0].Cells[1].Value = searchBox.Text;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            xamDataGrid1.DataSource = data.Where(d => d.Name.ToLower().Equals((searchBox.SelectedItem as ComboBoxItem).Content.ToString().ToLower())).ToList();
        }
    }
    public class DataItem : INotifyPropertyChanged
    {

        public DataItem() { }

        public DataItem(int id, string name)
        {
            _id = id;
            _name = name;
        }
        private int _id;
        public int ID
        {
            get { return _id; }
            set
            {
                _id = value;
                OnPropertyChanged("ID");
            }
        }
        private string _name;
        public string Name
        {
            get { return _name; }
            set
            {
                _name = value;
                OnPropertyChanged("Name");
            }
        }
        public event PropertyChangedEventHandler PropertyChanged;
        protected void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;

            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        public static ObservableCollection<DataItem> GetCollection()
        {
            ObservableCollection<DataItem> mycollection = new ObservableCollection<DataItem>();

            for (int i = 0; i < 100; i++)
            {
                mycollection.Add(new DataItem
                {
                    ID = i,
                    Name = "Name " + (i % 7),
                });
            }
            return mycollection;
        }
    }
}
